/*=============================================================================
	Networking api
=============================================================================*/

#ifndef _INC_XC_NETWORKING
#define _INC_XC_NETWORKING

#include "UnNet.h"


XC_CORE_API void CleanupBunch( FOutBunch* Bunch); //Prevent v436 destructor from killing the app
struct FArchiveHeader
{
	INT ArVer;
	INT ArNetVer;
	INT ArLicenseeVer;
	UBOOL ArIsLoading;
	UBOOL ArIsSaving;
	UBOOL ArIsTrans;
	UBOOL ArIsPersistent;
	UBOOL ArForEdit;
	UBOOL ArForClient;
	UBOOL ArForServer;
	UBOOL ArIsError;
};
struct XC_CORE_API FOutBunchHeader
{
	TArray<BYTE> Buffer;
	INT   Num;
	INT   Max;
	FOutBunch*		Next; //Starting offset of +8 in v440
	UChannel*		Channel;
	FTime			Time;
	UBOOL			ReceivedAck;
	INT				ChIndex;
	INT				ChType;
	INT				ChSequence;
	INT				PacketId;
	BYTE			bOpen;
	BYTE			bClose;
	BYTE			bReliable;

	//Editing across all versions
	static FOutBunchHeader* GetHeader( FOutBunch* Other);
};


//
// A bunch of data to send.
// This works in both v440 and v436
// Just remember to call Exit() when finished using
//
class XC_CORE_API FOutBunch_Hack : public FOutBunch // Size = 108 // Size  = 116 in v440
{ //This class should normalize it to 116 for proper stack allocation in GCC
private:
	BYTE Padding[7];
public:
	BYTE b440; //This byte is always free

	// Forward everything to Engine.dll
	FORCEINLINE FOutBunch_Hack()
	: FOutBunch()
	{
		Init();
	};
	FORCEINLINE FOutBunch_Hack( UChannel* InChannel, UBOOL bClose )
	: FOutBunch( InChannel, bClose)
	{
		Init();
	};
	
	//Data accessors
	FArchiveHeader* Archive();
	FOutBunchHeader* Bunch();
	
	void Exit();
	
private:
	void Init();
};

//============================================================================
#endif
/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
