//====================================================
// XC_CoreStatics
// Utils for UnrealScript usage, build 2
//
// You may code this in two different ways, be it via
// directly referencing this object, or by using a
// trick to avoid package dependancy.
//
// If the mod really requires these natives, then it's
// best to simply reference this object and use it's
// functions the old fashioned way.
//
// If the mod optionally uses this code, then using
// the XC_Engine workarounds is best, check XC_Engine
// documentation on how to add XC_Engine functionality
// without creating package dependancy.
//
//====================================================
class XC_CoreStatics expands Object
	abstract
	native;

var transient const editconst bool bGNatives; //True if commented out opcodes can be called directly
var const editconst int XC_Core_Version;	//Hardcoded, set by DLL
var const editconst int XC_Engine_Version; //Only set if XC_Engine is running
var transient float iC[2]; //If you want to internally clock

native /* (192)*/ static final function Color MakeColor( byte R, byte G, byte B, optional byte A);
native /* (238)*/ static final function string Locs( string InStr );
native /* (391)*/ static final function name StringToName( string S );
native /* (600)*/ static final function object FindObject( string ObjectName, class ObjectClass );
native /* (601)*/ static final function Class<Object> GetParentClass( Class<Object> ObjClass );
native /* (602)*/ static final iterator function AllObjects( class<Object> BaseClass, out Object Obj );
native /* (643)*/ static final function float AppSeconds();
native /*(3554)*/ static final function iterator ConnectedDests( NavigationPoint Start, out Actor End, out int ReachSpecIdx, out int PathArrayIdx);

//***************************** << - Returns B if A doesn't exist
native /*(3555)*/ static final operator(22) Object | (Object A, skip Object B);

//Ultra precise clocking, for checking small pieces of code
//This measurement is way more expensive than AppSeconds, don't keep it on final builds
native /*(3556)*/ static final function Clock( out float C[2]);
native /*(3557)*/ static final function float UnClock( out float C[2]);

native /*(3570)*/ static final function vector HNormal( vector A);
native /*(3571)*/ static final function float HSize( vector A);
native /*(3572)*/ static final function float InvSqrt( float C);


static function TestClock()
{
	local float Timer;
	Clock( default.iC );
	//Do something
	Timer = UnClock( default.iC );
	Log("Inner clock test, time measured: "$Timer);
}

defaultproperties
{
	XC_Core_Version=5
}
